package boxes.CircularShifterAbs.CircularShifter;

import datatypes.systems.*;
import interfaces.ICircularShift;
import interfaces.IStoreHelper;
import interfaces.ILine;
import datatypes.Word;
import datatypes.LStore;

public class CirShiftImp implements ICircularShift, IStoreHelper
{
	private BoxTop _box;
	private ILine ias;
	private LStore store;
	private int lineno;
	private int size;	//size of lines in the LienStorage
	
	public CirShiftImp(BoxTop mybox)
	{
		_box = mybox;
	}
	
	public void circularShift()
	{
		init();
		copyToLocalStore(); 
		for (int i = 0; i < size; i++)
			shiftWords(i);	
	}
	
	public LStore getStoreRef()
	{
		return store;	
	}
	//////////////private methods
	private void init()
	{
		// set for required interfaces
		// IAccessStore ws;
		InterfaceName name = new InterfaceName("ws");
		ias = (ILine)_box.getRequiredItf(name);
		size = ias.getTotalLineNo();
		lineno = size;
		store = new LStore();
	}	
	
	private void copyToLocalStore()
	{
		for (int i = 0; i < size; i++)
			store.add(i, ias.getLine(i));
	}
	
	// do circularshift for ith line 
	private void shiftWords(int line)
	{
		Word [] src = store.get(line);

		for (int i = 1; i < src.length ; i++)
		{
			src = shiftOneToRight(src);
			// add into LineStorage  
			store.add(lineno++, src);
		}
	}
	
	private Word [] shiftOneToRight(Word [] w)
	{
		int size_w = w.length;
		Word [] retu = new Word [size_w];
		
		retu[size_w-1] = w[0];
		for (int i = 0; i< size_w -1; i++)
			retu[i] = w[i+1];
		
		return retu;
	}	
}
