package boxes.IOBoxAbs.InputBox;

import java.io.*; 
import java.lang.*;
import java.util.*;
import interfaces.IReadIn;
import interfaces.IWriteOut;
import datatypes.systems.*;
import datatypes.Word;
import interfaces.IWriteLineStore;
import interfaces.IToWordArray;
import datatypes.SrcDesc;

public class RiImp implements IReadIn, IWriteOut
{
	private IWriteLineStore wls;
	private IToWordArray wa;
	
	private BoxTop _box;

	public RiImp(BoxTop mybox)
	{
		_box = mybox;
	}

	public void readIn()
	{
		init();
		writeMsg();
		readAns();		
	}
	
	// this provided implementation is for box InputBox, it does not care the writeout
	public void writeout() {};
	
	///////////////////private methods
	private void init()
	{
		// set required interface refs
		// IWriteLineStore wls, IToWordArray wa;
		InterfaceName name = new InterfaceName("wls");
		wls = (IWriteLineStore)_box.getRequiredItf(name);
		
		name = new InterfaceName("wa");
		wa = (IToWordArray)_box.getRequiredItf(name);
	}

	private void writeMsg()
	{
		System.out.println("Choose the following devices(1-" + SrcDesc.inputSrc.length+") for input");
		for (int i=0; i< SrcDesc.inputSrc.length; i++)
			System.out.println(i+1 + ". " + SrcDesc.inputSrc[i]);
	}
	
	private void readAns()
	{
		 int input = 0;
		 while ( (input <1) ||(input > SrcDesc.inputSrc.length) ) 
		 {
              		System.out.print("\nPress number (1-"+ SrcDesc.inputSrc.length+")" +", then <Enter>: ");
			
			Scanner sc = new Scanner(System.in);
			try{
			input = sc.nextInt();
			} catch (Exception e) {System.out.println ("You did not enter a number");}
		 }
		 
	 	System.out.println("\nData will be " + SrcDesc.inputAction[input-1]);
	 	
	 	if (input == 1)
	 	{	// read from File	
	 		System.out.println("Please enter the source file name:");
	 		readFromFile();
		}
		
		if (input == 2)
		{	// read from keyboard
			readFromKeyBoard();
		}
	}

	private void readFromFile()
	{
		String filename = "";
		int lineno = 0;
		
		Scanner sc = new Scanner(System.in);
		if (sc.hasNextLine())
			filename = sc.nextLine();
		
		try{
     			BufferedReader r = new BufferedReader(new FileReader(filename));
     			// get line
     			String line; 
     			while((line = r.readLine()) != null)
     			{
     				// ask WordWrapper to convert the string to Word []
     				// ask LineStorage to store the Word [] 
				wls.addLine(lineno++ ,wa.strToWords(line));
    			}
    			r.close();
		}
		catch(FileNotFoundException fe)
		{
			System.err.println("Cannot open: " + filename);
		}
		catch (IOException e) 
		{	 System.err.println(e);		}
	}
	
	private void readFromKeyBoard()
	{
		String line;
		int lineno = 0;
		
		System.out.println("Please enter your text. Finish each line with <Ret>. "+
					"Finish text with <Ctrl>Z and <Ret>.");
		
		Scanner sc = new Scanner(System.in);
		while(sc.hasNextLine())
		{	// ask WordWrapper to convert the string to Word []
     			// ask LineStorage to store the Word [] 
     			line = sc.nextLine();
		      	wls.addLine(lineno++ ,wa.strToWords(line));
		}
	}
		
}




