package boxes.IOBoxAbs.OutputBox;

import java.io.*; 
import java.util.*;
import interfaces.IReadIn;
import interfaces.IWriteOut;
import datatypes.systems.*;
import datatypes.Word;
import interfaces.ILine;
import interfaces.IToWordArray;
import datatypes.SrcDesc;

public class WoImp implements IReadIn, IWriteOut
{
	private ILine ln;
	private IToWordArray wa;
	
	private BoxTop _box;

	public WoImp(BoxTop mybox)
	{
		_box = mybox;
	}

	// this provided implementation is for box OutputBox, it does not care the ReadIn()
	public void readIn()
	{};
	
	public void writeout() 
	{
		init();
		writeMsg();
		readAns();		
	}
	
	///////////////////private methods
	private void init()
	{
		// set required interface refs
		// ILine ln, IToWordArray wa;
		InterfaceName name;
		
		name = new InterfaceName("wa");
		wa = (IToWordArray)_box.getRequiredItf(name);
		
		name = new InterfaceName("ln");
		ln = (ILine)_box.getRequiredItf(name);		
	}

	private void writeMsg()
	{
		System.out.println("Choose the following devices(1-" + SrcDesc.inputSrc.length+") for output");
		for (int i=0; i< SrcDesc.outputSrc.length; i++)
			System.out.println(i+1 + ". " + SrcDesc.outputSrc[i]);
	}
	
	private void readAns()
	{
		int input = 0;
		 while ( (input <1) ||(input > SrcDesc.inputSrc.length) ) 
		 {
              		System.out.print("\nPress number (1-"+ SrcDesc.inputSrc.length+")" +", then <Enter>: ");
			
			Scanner sc = new Scanner(System.in);
			try{
			input = sc.nextInt();
			} catch (Exception e) {System.out.println ("You did not enter a number");}
		 }
		 
	 	System.out.println("\nData will be " + SrcDesc.outputAction[input-1]);
	 	
	 	if (input == 1)
	 	{	// write to File	
	 		System.out.println("Please enter the destination file name:");
	 		writeToFile();
		}
		
		if (input == 2)
		{	// write to screen
			writeToScreen();
		}

	}

	private void writeToFile()
	{
		String filename = "";
		int lineno = 0;
		
		try
		{ 
			BufferedReader keyb = new BufferedReader( new InputStreamReader(System.in)); 
			filename = keyb.readLine(); 
			keyb.close();     
		} catch (Exception e){System.err.println(e); } 
		
		try {
		        BufferedWriter out = new BufferedWriter(new FileWriter(filename));
		        int size = ln.getTotalLineNo();
			for (int i = 0; i<size; i++)
		        	out.write(wa.wordsToString(ln.getLine(i)) + "\n");
		        out.close();
		} catch (IOException e) { System.err.println(e); } 
	}
	
	private void writeToScreen()
	{
		int size = ln.getTotalLineNo();
		for (int i = 0; i<size; i++)
			System.out.println(wa.wordsToString(ln.getLine(i)));
	}
	
	
}
