package boxes.MasterControlAbs.MasterControl;

import java.io.*; 
import interfaces.IKwic;
import datatypes.systems.*;
import interfaces.IReadIn;
import interfaces.ICircularShift;
import interfaces.IAlphabetize;
import interfaces.IWriteOut;

public class KwicImp implements IKwic
{
	private BoxTop _box;
	
	private IReadIn ri;
	private ICircularShift cs;
	private IAlphabetize ap;
	private IWriteOut wo;

	public KwicImp(BoxTop mybox)
	{
		_box = mybox;
	}

	public void kwic()
	{
		init();
		ri.readIn();
		cs.circularShift();
		ap.alphabetize();
		wo.writeout();
	}

	/////////////////////private methods
		
	private void init()
	{
		// set required interface refs
		InterfaceName name;
		name = new InterfaceName("ap");
		ap = (IAlphabetize)_box.getRequiredItf(name);		
		name = new InterfaceName("ri");
		ri = (IReadIn)_box.getRequiredItf(name);			
		name = new InterfaceName("cs");
		cs = (ICircularShift)_box.getRequiredItf(name);	
		name = new InterfaceName("wo");
		wo = (IWriteOut)_box.getRequiredItf(name);		
		
	}

}